diff -Nur madwifi-trunk-r3767-20080711.orig/ath/if_ath.c madwifi-trunk-r3767-20080711/ath/if_ath.c
--- madwifi-trunk-r3767-20080711.orig/ath/if_ath.c	2008-07-13 08:25:16.000000000 +0200
+++ madwifi-trunk-r3767-20080711/ath/if_ath.c	2008-07-13 08:38:17.000000000 +0200
@@ -340,6 +340,7 @@
 static int ath_outdoor = AH_FALSE;		/* enable outdoor use */
 static int ath_xchanmode = AH_TRUE;		/* enable extended channels */
 static int ath_maxvaps = ATH_MAXVAPS_DEFAULT;   /* set default maximum vaps */
+static int bstuck_thresh = BSTUCK_THRESH;       /* Stuck beacon count required for reset */
 static char *autocreate = NULL;
 static char *ratectl = DEF_RATE_CTL;
 static int rfkill = 0;
@@ -384,6 +385,7 @@
 #ifdef ATH_CAP_TPC
 MODULE_PARM(hal_tpc, "i");
 #endif
+MODULE_PARM(bstuck_thresh, "i");
 MODULE_PARM(autocreate, "s");
 MODULE_PARM(ratectl, "s");
 MODULE_PARM(intmit, "i");
@@ -398,6 +400,7 @@
 #ifdef ATH_CAP_TPC
 module_param(hal_tpc, int, 0600);
 #endif
+module_param(bstuck_thresh, int, 0600);
 module_param(autocreate, charp, 0600);
 module_param(ratectl, charp, 0600);
 module_param(intmit, int, 0600);
@@ -411,6 +414,7 @@
 MODULE_PARM_DESC(hal_tpc, "Disables manual per-packet transmit power control and "
 		"lets this be managed by the HAL.  Default is OFF.");
 #endif
+MODULE_PARM_DESC(bstuck_thresh, "Override default stuck beacon threshold");
 MODULE_PARM_DESC(autocreate, "Create ath device in "
 		"[sta|ap|wds|adhoc|ahdemo|monitor] mode. defaults to sta, use "
 		"'none' to disable");
@@ -5115,7 +5119,7 @@
 		DPRINTF(sc, ATH_DEBUG_BEACON_PROC,
 			"Missed %u consecutive beacons (n_beacon=%u)\n",
 			sc->sc_bmisscount, n_beacon);
-		if (sc->sc_bmisscount > BSTUCK_THRESH)
+		if (sc->sc_bmisscount > bstuck_thresh)
 			ATH_SCHEDULE_TQUEUE(&sc->sc_bstucktq, needmark);
 		return;
 	}
@@ -5286,7 +5290,7 @@
 	 *     check will be true, in which case return
 	 *     without resetting the driver.
 	 */
-	if (sc->sc_bmisscount <= BSTUCK_THRESH)
+	if (sc->sc_bmisscount <= bstuck_thresh)
 		return;
 	EPRINTF(sc, "Stuck beacon; resetting (beacon miss count: %u)\n",
 		sc->sc_bmisscount);
